#include<bits/stdc++.h>
using namespace std;
int main(){
ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n,len=0;
    cin>>n;
    pair<int,bool> x[2*n];
    pair<int,int> a;
    for(int i=0; i<n; i++){
        cin>>a.first>>a.second;
        x[i*2]={a.first,1};
        x[i*2+1]={a.second,0};
        len=max(len,a.second);
    }
    sort(x,x+2*n);
    int pos=0,now=0,ans=0,cnt;
    for(int j=1; j<=len; j++){
        while(x[pos].first==j){
            if(x[pos].second)now++;
            else now--;
            pos++;
        }
        if(now==ans)cnt++;
        else if(now>ans){
            ans=now;
            cnt=1;
        }
    }
    cout<<ans<<'\n'<<cnt;
return 0;
}
